﻿@using System.Web.UI.WebControls;

@Html.DevExpress().GridView(
        gridView =>
        {
            gridView.Name = "LRPLDAPDGridView";
            gridView.CallbackRouteValues = new { Controller = "ProblemPart", Action = "PartialPartList" };
            gridView.KeyFieldName = "NO_INDEX";
            //gridView.ClientSideEvents.BeginCallback = "OnLRPLDAPDGridViewBeginCallback";

            gridView.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
            gridView.Width = Unit.Percentage(100);

            gridView.Settings.ShowFilterRow = true;
            gridView.Settings.ShowFilterRowMenu = true;
            gridView.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
            gridView.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
            gridView.Settings.ShowColumnHeaders = true;
            gridView.SettingsEditing.Mode = GridViewEditingMode.EditFormAndDisplayRow;

            //gridView.CommandColumn.Visible = true;
            //gridView.CommandColumn.ClearFilterButton.Visible = true;
            //gridView.CommandColumn.EditButton.Visible = true;
            //gridView.CommandColumn.DeleteButton.Visible = true;
            
            //gridView.CommandColumn.Visible = true;
            //gridView.CommandColumn.Caption = "#";
            
            //gridView.CommandColumn.Width = Unit.Pixel(50);           

            gridView.Columns.Add(column => {
                column.SetDataItemTemplateContent(
                  content =>
                  {
                      Html.DevExpress().HyperLink(
                          link =>
                          {
                              link.Name = string.Format("lnkEdit_{0}", DataBinder.Eval(content.DataItem,"NO_INDEX") ) ;
                              link.NavigateUrl = "javascript:void(0)";
                              link.Properties.ClientSideEvents.Click = "OnClickEditPopupGrid";
                              link.Properties.Text = "Edit";
                              link.ClientVisible = true;
                          }).Render();
                      
                        ViewContext.Writer.Write(
                                "&nbsp"
                                );
                      
                        Html.DevExpress().HyperLink(
                            link =>
                            {
                                link.Name = string.Format("lnkDelete_{0}", DataBinder.Eval(content.DataItem,"NO_INDEX") ) ;
                                link.NavigateUrl = "javascript:void(0)";
                                link.Properties.ClientSideEvents.Click = "OnClickDeletePopupGrid";
                                link.Properties.Text = "Delete";
                                link.ClientVisible = true;
                            }).Render();                      
                        });
            });

            gridView.CustomJSProperties = (s, e) =>
            {
                MVCxGridView grid = (MVCxGridView)s;
                int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
                int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
                object[] PartNo = new object[end - startIndex];
                object[] PartName = new object[end - startIndex];
                object[] qty = new object[end - startIndex];
                object[] reason = new object[end - startIndex];

                for (int n = startIndex; n < end; n++)
                {
                    PartNo[n - startIndex] = grid.GetRowValues(n, "PART_NO");
                    PartName[n - startIndex] = grid.GetRowValues(n, "PART_NAME");
                    qty[n - startIndex] = grid.GetRowValues(n, "QTY");                   
                    reason[n - startIndex] = grid.GetRowValues(n, "REASON");
                }

                e.Properties["cpPartNo"] = PartNo;
                e.Properties["cpPartName"] = PartName;
                e.Properties["cpQty"] = qty;
                e.Properties["cpReason"] = reason;
                grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
            };
            
            //gridView.SetEditFormTemplateContent(
            //    column =>
            //    {
            //        var user = TempData["PartList"] != null ? TempData["PartList"] : column.DataItem;
            //        ViewContext.Writer.Write(
            //            "<div class=\"edit_form\">" +
            //            "<div class=\"line\">" +
            //            "<table>" +
            //            "<tr><td>"
            //            );
            //        Html.DevExpress().Label(
            //            edit =>
            //            {
            //                edit.Text = "Part No";
            //                edit.Width = Unit.Pixel(48);
            //            }).Render();

            //        ViewContext.Writer.Write(
            //            "</td><td>"
            //            );
            //        //Html.DevExpress().TextBox(
            //        //    edit =>
            //        //    {
            //        //        edit.Name = "txtPartNoPopup";
            //        //        edit.Width = Unit.Pixel(80);
            //        //    }).Bind(DataBinder.Eval(column.DataItem, "PART_NO")).Render();

            //        Html.Common().DevExpress().GridLookup(
            //        s =>
            //        {
            //            s.Name = "grlPartNo2";
            //            s.GridProperties.KeyFieldName = "PartNo";
            //            //s.Text = (string)ViewData["PartData"];
            //            //s.GridProperties.DataSource = (List<Portal.Models.Part.PartData>)ViewData["PartData"];
            //            s.Width = System.Web.UI.WebControls.Unit.Pixel(120);
            //            s.GridProperties.Width = System.Web.UI.WebControls.Unit.Pixel(320);
            //            s.GridProperties.CallbackRouteValues = new { Controller = "LSRRecording", Action = "PartNoPartial2" };
            //            s.GridProperties.SettingsBehavior.AllowSelectSingleRowOnly = true;
            //            s.GridProperties.SettingsPager.PageSize = 100;
            //            //s.OnSelectionChanged = "OnSelectionChangedgrlPartNo";
            //            s.GridProperties.Columns.Add(c =>
            //            {
            //                c.Name = "PartNo";
            //                c.FieldName = "PartNo";
            //                c.Caption = "Part No";
            //                c.Width = System.Web.UI.WebControls.Unit.Pixel(80);
            //                c.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            //            });
            //            s.GridProperties.Columns.Add(c =>
            //            {
            //                c.Name = "PartName";
            //                c.FieldName = "PartName";
            //                c.Caption = "Part Name";
            //                c.Width = System.Web.UI.WebControls.Unit.Pixel(240);
            //                c.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            //            });
            //            //}).Bind(ViewData["PartData"]).GetHtml();
            //        }).Bind(ViewData["PartData2"]).Render();
                    
            //        ViewContext.Writer.Write(
            //            "</td><td style=\"padding-left:20px\">"
            //            );
            //        Html.DevExpress().Label(
            //            edit =>
            //            {
            //                edit.Text = "Part Name";
            //                edit.Width = Unit.Pixel(60);
            //            }).Render();

            //        ViewContext.Writer.Write(
            //            "</td><td>"
            //            );
            //        Html.DevExpress().TextBox(
            //            edit =>
            //            {
            //                edit.Name = "txtPartNamePopup";
            //                edit.Width = Unit.Pixel(140);
            //            }).Bind(DataBinder.Eval(column.DataItem, "PART_NAME")).Render();

            //        ViewContext.Writer.Write(
            //            "</td><td style=\"padding-left:20px\">"
            //            );
            //        Html.DevExpress().Label(
            //            edit =>
            //            {
            //                edit.Text = "Qty";
            //                edit.Width = Unit.Pixel(28);
            //            }).Render();

            //        ViewContext.Writer.Write(
            //            "</td><td>"
            //            );
            //        Html.DevExpress().TextBox(
            //            edit =>
            //            {
            //                edit.Name = "txtQtyPopup";
            //                edit.Width = Unit.Pixel(40);
            //                //edit.Properties.ClientSideEvents.KeyPress = "IsNumeric";
            //                //edit.Properties.MaskSettings.Mask = "<999>";
            //            }).Bind(DataBinder.Eval(column.DataItem, "QTY")).Render();

            //        ViewContext.Writer.Write(
            //            "</td><td style=\"padding-left:20px\">"
            //            );
            //        Html.DevExpress().Label(
            //            edit =>
            //            {
            //                edit.Text = "Reason";
            //                edit.Width = Unit.Pixel(48);
            //            }).Render();

            //        ViewContext.Writer.Write(
            //            "</td><td>"
            //            );
            //        Html.DevExpress().ComboBox  (
            //            edit =>
            //            {
            //                edit.Name = "cmbReasonPopup";
            //                edit.Width = Unit.Pixel(120);
            //                edit.Properties.Items.Add("Damage");
            //                edit.Properties.Items.Add("Missing Part");
            //                edit.Properties.Items.Add("Shortage");
            //            }).Bind(DataBinder.Eval(column.DataItem, "REASON")).Render();


            //        ViewContext.Writer.Write(
            //            "</td>" +
            //            "<tr></table>" +
            //            "<table  width=\"658px\" style=\"text-align:right;\" >" +
            //            "<tr><td align=\"right\">"
            //            );
            //        Html.DevExpress().Button(
            //            btn =>
            //            {
            //                btn.Name = "btnUpdate";
            //                btn.Text = "Update";
            //                btn.Width = Unit.Pixel(80);
            //                btn.ClientSideEvents.Click = "OnLSRRecordingPopupUpdate";
            //            }).Render();

            //        ViewContext.Writer.Write(
            //           "</td><td width=\"82px\">"
            //           );
            //        Html.DevExpress().Button(
            //            btn =>
            //            {
            //                btn.Name = "btnCancel";
            //                btn.Text = "Cancel";
            //                btn.Width = Unit.Pixel(80);
            //                btn.ClientSideEvents.Click = "OnLSRRecordingPopupClosing";
            //            }).Render();
                    
            //        ViewContext.Writer.Write(
            //            "</td></tr>" +
            //            "</table>"
            //            );
            //    });
            
            gridView.Columns.Add(
                column =>
                {
                    column.Name = "No";
                    column.FieldName = "NO_INDEX";
                    column.Caption = "No";
                    
                    column.Width = Unit.Pixel(40);
                    column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    column.Settings.AllowAutoFilter = DefaultBoolean.False;
                });
            
            gridView.Columns.Add(
                column =>
                {
                    column.Name = "PART_NO";
                    column.FieldName = "PART_NO";
                    column.Caption = "Part Number";
                    
                    column.Width = Unit.Pixel(120);
                    column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                });
            
            gridView.Columns.Add(
                column =>
                {
                    column.Name = "PART_NAME";
                    column.FieldName = "PART_NAME";
                    column.Caption = "Part Name";
                    
                    column.Width = Unit.Pixel(240);
                    column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                });
            
            gridView.Columns.Add(
                column =>
                {
                    column.Name = "QTY";
                    column.FieldName = "QTY";
                    column.Caption = "Qty";
                    
                    column.Width = Unit.Pixel(50);
                    column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;                    
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    column.CellStyle.BackColor = System.Drawing.Color.Yellow;
                });
            
            gridView.Columns.Add(
                column =>
                {
                    column.Name = "REASON";
                    column.FieldName = "REASON";
                    column.Caption = "Reason";

                    column.Width = Unit.Pixel(120);
                    column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    column.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    //column.ColumnType = MVCxGridViewColumnType.ComboBox;

                    //column.SetDataItemTemplateContent(
                    //    content =>
                    //    {
                    //        Html.DevExpress().ComboBox(
                    //            comboBox =>
                    //            {
                    //                comboBox.Name = "LRPLDAPDReasonOption" + content.VisibleIndex;

                    //                comboBox.Properties.Items.Add("Damage");
                    //                comboBox.Properties.Items.Add("Missing Part");
                    //                comboBox.Properties.Items.Add("Shortage");

                    //                comboBox.SelectedIndex = -1;
                    //                comboBox.Width = Unit.Pixel(110);
                    //            }).Render();
                    //    });
                        
                    //var comboProperties = column.PropertiesEdit as ComboBoxProperties;
                    //comboProperties.Items.Add("");
                    //comboProperties.Items.Add("Shortage");
                    //comboProperties.Items.Add("Misspart");
                    //comboProperties.Items.Add("Damage");
                }); 
        }).Bind(TempData["PartList"]).GetHtml()